﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;

namespace Cursed
{
    public class Const
    {
        public const bool FullScreen = false;

        public const int TicksBetweenActiveChecks = 60;

        //if this is true, update is called from draw, rather than from XNA (lockstep forcing)
        public const bool UpdateWithDraw = true;

        public const float ViewSize = 12;
        public const float ActiveRegionBuffer = 12;

        //the smaller this is, the slower obj overlaps are resolved. smaller = smoother.
        public const float maxPush = 0.05f;
        //for collisions. 1 = elastic, 0 = inelastic. out of that range makes no sense.
        public const float RestitutionCoeff = 0f;

        public const float FogFactor = 8;
        public const float FogWidth = 8;

        //for quad-tree collision detection - the number of entities before a node splits
        public const int MaxQTChildren = 6;

        public const int PushIterations = 1;
        public const float PushFactor = 1f;

        //drawing orders
        public const float WandDepth = -50f;
        public const float SparkDepth = -50f;
        public const float DialogDepth = -49f;
        public const float TriggerZoneDepth = -47f;
        public const float LifeBarDepth = -20f;
        public const float ChooserDepth = -15;
        public const float FogDepth = -10;
        public const float TreeDepth = -7f;
        public const float WallDepth = -5f;
        public const float DoorClosedDepth = -5f;
        public const float AttackDepth = -2.0f;
        public const float ShrubDepth = -1.5f;
        public const float FamiliarDepth = -1.2f;
        public const float DruidDepth = -1.1f;
        public const float DemonDepth = -1.0f;
        public const float CrystalDepth = -0.6f;
        public const float WoodDepth = -.4f;
        public const float LifeBlobDepth = -.3f;
        public const float SpawnDepth = -.2f;
        public const float StickerDepth = -.175f;
        public const float BloodStainDepth = -.15f;
        public const float FootSwitchDepth = -.1f;
        public const float ExitDepth = -.1f;
        public const float EntranceDepth = -.1f;
        public const float BridgeDepth = -0.075f;
        public const float FlowerDepth = -.02f;
        public const float WaterDepth = -0.01f;
        public const float GroundDepth = 0f;
        public const float DoorOpenDepth = .2f;

        //gob stuff
        public const float RescanTime = .1f;

        //druid stuff
        public const float LifeSpellAmount = .25f;
        public const float LifeSpellMana = .020f;
        public const float LifeSpellCoolDown = 0.1f;
        public const float LifePerCast = 1f;
        public const float LifeRange = .5f;
        public const float LifeDecay = .05f;
        public const float LifeAspect = 2.5f;

        public const float WoodSpellMana = .020f;
        public const float WoodSpellCoolDown = 0.2f;
        public const float WoodPerCast = 5;
        public const float WoodRange = .5f;
        public const float WoodSize = .4f;
        public const float WoodHealth = .25f;

        public const float DruidRepoopTime = 0.18f;
        public const float DruidPoopDecay = 0.5f;
        public const float DruidPoopAmount = 0.1f;

        public const float MaxMana = 1;
        public const float ManaRegen = .2f;
        public const float DruidHealth = 3;
        public const float DruidEnergy = 1;

        //public const float DruidMass;
        public const float SummonCost = 0.75f;
        public const float TeleportCost = 0.5f;

        //demon stuff
        public const float DemonClawStrength = 0.25f;
        public const float DemonClawAttackDuration = .2f;
        public const float DemonClawAttackCoolDown = 0.5f;
        public const float DemonSpinStrength = 0.75f;
        public const float DemonSpinAttackDuration = .4f;
        public const float DemonSpinAttackCoolDown = 2f;

        public const float LungeCooldown = 2;
        public const float LungeDamageFactor = 3;

        public const float LifeBlobDrainRate = 3;

        public const float MaxPathCost = 10;
        public const float MaxPathPops = 10;

        //familiar AI
        public const float FamiliarEnergyVisibilityThreshold = -1;

        //Colors
        public static Color PrimaryGreen = new Color(64, 116, 64);
        public static Color PrimaryBrown = new Color(128, 58, 0);
        public static Color PrimaryPurple = new Color(42, 4, 86);
        public static Color DarkGreen1 = new Color(56, 82, 24);
        public static Color DarkGreen2 = new Color(37, 68, 0);
        public static Color LightGreen1 = new Color(125, 203, 65);
        public static Color DarkBrown = new Color(90, 55, 27);
        public static Color White = new Color(.9f, .9f, .9f);
        public static Color LightPurple1 = new Color(165, 64, 193);
        public static Color LightPurple2 = new Color(175,112,193);
        public static Color LightBrown1 = new Color(209,127,66);
        public static Color LightBrown2 = new Color(209,157,119);
        public static Color Pink1 = new Color(204, 117, 142);
        public static Color Pink2 = new Color(204, 65, 105);
        public static Color Black = new Color(0, 0, 0);
        public static Color Gray = new Color(.5f, .5f, .2f);
        public static Color Blue = new Color(1, 62, 79);
        public static Color TransparentBlue = new Color(1, 62, 79, 60);
       
        //GamePad
        public static float MouseSpeed = 15f;
        public static float TriggerThreshold = .1f;

        //post processing
        public const int LifeMapCols = 40;
        public const int LifeMapRows = 30;
        public const int LifeSkip = 3;
        public const float baseLife = .1f;

        public const float DieFadeOutTime = 0.5f;
        public const float SpawnFadeInTime = 0.5f;

        public const float LoadFadeTime = 0.5f;

        public const float menuButtonHeight = .1f;
        public const float menuButtonWidth = .2f;
    }
}
