﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using Cursed.view.renders;
using Microsoft.Xna.Framework;
using Cursed.geom;
using Cursed.gob.mob.kob;

namespace Cursed.gob.mob
{
    public class LifeBarInfo : MobInfo
    {
        
        public LifeBarInfo()
            : base()
        {
            Depth = Const.LifeBarDepth;
            delay = .75f;
        }

        float delay;
        public float Delay
        {
            get{return delay;}
            set{delay = value;}
        }

    }
    public class LifeBar : Mob
    {
        public Mob source;
        float elapsed;
        public LifeBar(CursedGame game, LifeBarInfo info)
            : base(game, info)
        {
            Transcendent = true;
            Transient = true;
            IsEffect = true;
        }

        public Mob Source
        {
            get { return source; }
            set { source = value; }
        }

        public override void Load()
        {
            shape = source.Shape;// new Rect(Vector2.Zero, source.MobInfo.Scale, source.MobInfo.Scale);
            MobInfo.Scale = source.MobInfo.Scale * 2;
            renderInfo = new LifebarRenderInfo(shape.Bounds);
            ((LifebarRenderInfo)renderInfo).Texture = CursedGame.textureLib.GetTexture("LifeBar");
            addRender(CursedGame.getRender(Cursed.view.renders.Render.RenderType.LifebarRender), renderInfo);
        }
        public override void Update(Microsoft.Xna.Framework.GameTime gameTime)
        {
            if (elapsed > 0)
            {
                elapsed -= gameTime.ElapsedGameTime.Milliseconds * .001f;
                if (elapsed < 0)
                    elapsed = 0;
            }
            GobInfo.Loc = source.GobInfo.Loc;
            //MobInfo.Scale = source.MobInfo.Scale * 2f;

            ((LifebarRenderInfo)RenderInfo).Visibility = elapsed / LifeBarInfo.Delay;
            base.Update(gameTime);
           
        }
        public LifeBarInfo LifeBarInfo
        {
            get { return (LifeBarInfo)info; }
        }
        public void hit()
        {
            elapsed = LifeBarInfo.Delay;
        }
        public float Percent
        {
            get { return ((LifebarRenderInfo)RenderInfo).Percent; }
            set { ((LifebarRenderInfo)RenderInfo).Percent = value; }
        }
        public override void Unload()
        {
            base.Unload();
        }
    }
}
