﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Cursed.geom;
using Microsoft.Xna.Framework;

namespace Cursed.gob.mob
{
    public class StickerInfo : MobInfo
    {
        public StickerInfo()
            : base()
        {
            Stuck = true;
            Depth = Const.StickerDepth;
        }

        public override Gob Create(CursedGame game)
        {
            return new Sticker(game, this);
        }
    }

    public class Sticker : Mob
    {
        public Sticker(CursedGame game, StickerInfo info)
            : base(game, info)
        {
            Transcendent = true;
            Inert = false;
            Transient = false;
            IsEffect = false;
        }
        public override void Load()
        {
            shape = new Rect(Vector2.Zero, 1, 1);
            if (info.Preset == "Flowers")
                info.Depth = Const.FlowerDepth;
            base.Load();
        }
    }
}
