﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Cursed.geom;
using Microsoft.Xna.Framework;
using Cursed.view.renders;
using Cursed.input;
using Cursed.gob.mob.effects;
using Microsoft.Xna.Framework.Graphics;

namespace Cursed.gob.mob
{
    class TrailInfo : MobInfo
    {
        float scaleX;

        public float ScaleX
        {
            get { return scaleX; }
            set { scaleX = value; }
        }
        float scaleY;

        public float ScaleY
        {
            get { return scaleY; }
            set { scaleY = value; }
        }
        public TrailInfo()
            :base()
        {
            scaleX = 1f;
            scaleY = 1f;
            Depth = Const.WandDepth;
        }
    }
    class Trail : Mob
    {
        public Trail(CursedGame game, TrailInfo info)
        :base(game,info)
        {

        }
        public override void Load()
        {
            IsEffect = true;
            Transcendent = true;
            Transient = true;
            shape = new Rect(Vector2.Zero, 1, 1);
            base.Load();
        }
        public override void Update(GameTime gameTime)
        {
            ((SpriteRenderInfo)RenderInfo).scaleX = TrailInfo.ScaleX;
            ((SpriteRenderInfo)RenderInfo).scaleY = TrailInfo.ScaleY;
            base.Update(gameTime);
        }
        public TrailInfo TrailInfo
        {
            get { return (TrailInfo)info; }
            
        }
    }
}
