﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using System.Runtime.Serialization;
using Cursed.view.renders;
using Cursed.geom;
using Microsoft.Xna.Framework;
using Cursed.gob.mob.effects;

namespace Cursed.gob.tile
{
    public class GroundInfo : TileInfo
    {
        // the resistance this ground has to things walking over it
        float drag;
        // the purchase this ground provides to things walking over it
        float friction;

        public GroundInfo(int x, int y)
            : base(x, y)
        {
            drag = 0;
            friction = 1;
            Depth = Const.GroundDepth;
            Texture = "StoneFloor";
            Preset = "StoneFloor";
        }

        public override Gob Create(CursedGame game)
        {
            return new Ground(game, this);
        }

        public float Drag
        {
            get { return drag; }
            set { drag = value; }
        }

        public float Friction
        {
            get { return friction; }
            set { friction = value; }
        }
    }
    public class Ground : Tile
    {
        public Ground(CursedGame game, GroundInfo info)
            : base(game, info)
        {
            Transcendent = true;
            Inert = true;
        }

        public GroundInfo GroundInfo
        {
            get { return (GroundInfo)info; }
        }
    }

    public class BridgeInfo : GroundInfo
    {
        public BridgeInfo(int x, int y)
            : base(x, y)
        {
            Depth = Const.BridgeDepth;
        }

        public override Gob Create(CursedGame game)
        {
            return new Bridge(game, this);
        }
    }

    public class Bridge : Ground
    {
        public Bridge(CursedGame game, BridgeInfo info)
            : base(game, info)
        {
            Transcendent = true;
            Inert = true;
        }

        public BridgeInfo BridgeInfo
        {
            get { return (BridgeInfo)info; }
        }
    }
}
