﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using System.Windows.Media;
using Cursed.view;
using Cursed.geom;
using System.Runtime.Serialization;
using Cursed.view.renders;
using Cursed.gob.mob.effects;

namespace Cursed.gob.tile
{
    public class TileInfo : GobInfo
    {
        int x, y;

        public TileInfo(int x, int y)
            : base()
        {
            this.x = x;
            this.y = y;
            Loc = new Vector2(x, y);
        }

        public int X
        {
            get { return x; }
            set
            {
                x = value;
                Loc = new Vector2(x, y);
            }
        }
        public int Y
        {
            get { return y; }
            set
            {
                y = value;
                Loc = new Vector2(x, y);
            }
        }
    }

    public class Tile : Gob
    {
        public Tile(CursedGame game, TileInfo info)
            : base(game, info)
        {
            Inert = true;
            GobInfo.Loc = new Vector2(info.X, info.Y);
        }

        public override void Load()
        {
            base.Load();
            shape = new Rect(Vector2.Zero, 1, 1);
        }

        public override void Update(GameTime gameTime)
        {
            updateTransform();
            updateRenderTransform(renderInfo);
            base.Update(gameTime);
        }

        protected void updateTransform()
        {
            if (shape != null)
                shape.setTransform(GobInfo.Loc, 0, 1);
        }

        protected void updateRenderTransform(RenderInfo rInfo)
        {
            if (rInfo != null)
                rInfo.Transform = Microsoft.Xna.Framework.Matrix.CreateTranslation(GobInfo.Loc3);
        }

        public int X
        {
            get { return TileInfo.X; }
        }

        public int Y
        {
            get { return TileInfo.Y; }
        }

        public TileInfo TileInfo
        {
            get { return (TileInfo)info; }
        }
    }
}
