﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using System.Runtime.Serialization;
using Cursed.geom;
using Microsoft.Xna.Framework;

namespace Cursed.gob.tile
{
    public class WallInfo : TileInfo
    {
        bool isShort;

        public WallInfo(int x, int y)
            : base(x, y)
        {
            isShort = false;
            Depth = Const.WallDepth;
            Texture = "RockWall";
            Preset = "StoneWall";
        }

        public override Gob Create(CursedGame game)
        {
            return new Wall(game, this);
        }

        public bool IsShort
        {
            get { return isShort; }
            set { isShort = value; }
        }
    }

    public class Wall : Tile
    {
        public Wall(CursedGame game, WallInfo info)
            : base(game, info)
        {
            Transcendent = false;
            Inert = true;
            DepthSpan = 1;
        }

        public override void Load()
        {
            base.Load();
            shape = new Rect(new Vector2(0, 0), 1, 1);
        }

        public WallInfo WallInfo
        {
            get { return (WallInfo)info; }
        }
    }
}
