﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Cursed.gob;
using Cursed.gob.mob;
using Microsoft.Xna.Framework;


namespace Cursed.input
{
    class DialogController : Controller
    {
        CursedGame game;
        List<Line> dialog;
        float elapsedTime;
        bool activated = false;
        public DialogController(CursedGame game, int scene)
        {
            this.game = game;
            dialog = Dialog.getScene(scene);
            elapsedTime = 0;
        }

        public override void act(Microsoft.Xna.Framework.GameTime time)
        {
            if (!activated && ((Gob)Target).GobInfo.Triggered)
            {
                activated = true;
            }  
            if(activated)
            {
                elapsedTime += time.ElapsedGameTime.Milliseconds * .001f;
                List<Line> remove = new List<Line>();
                foreach (Line line in dialog)
                {
                    if (line.StartTime <= elapsedTime)
                    {
                        remove.Add(line);
                        System.Console.WriteLine(line.Text);
                        DialogMobInfo info = new DialogMobInfo();
                        info.Label = line.Label;
                        info.Line = line;
                        game.AddGob(new DialogMob(game, info));
                    }
                }
                foreach (Line line in remove)
                {
                    dialog.Remove(line);
                }
            }
        }
        public override void cleanup()
        {
            //wut
        }
    }
}
