﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Input;
using Cursed.view;
using Microsoft.Xna.Framework;
using Cursed.gob.mob;

namespace Cursed.input
{
    public class GamePadInfo : ControlInfo
    {
        Vector2 leftStick;

        public Vector2 LeftStick
        {
            get { return leftStick; }
            set { leftStick = value; }
        }
        Vector2 rightStick;

        public Vector2 RightStick
        {
            get { return rightStick; }
            set { rightStick = value; }
        }
        bool a;

        public bool A
        {
            get { return a; }
            set { a = value; }
        }
        bool x;

        public bool X
        {
            get { return x; }
            set { x = value; }
        }
        bool b;

        public bool B
        {
            get { return b; }
            set { b = value; }
        }
        bool y;

        public bool Y
        {
            get { return y; }
            set { y = value; }
        }
        bool start;

        public bool Start
        {
            get { return start; }
            set { start = value; }
        }
        bool rightTrigger;

        public bool RightTrigger
        {
            get { return rightTrigger; }
            set { rightTrigger = value; }
        }
        bool leftTrigger;

        public bool LeftTrigger
        {
            get { return leftTrigger; }
            set { leftTrigger = value; }
        }

        public GamePadInfo()
            : base()
        {
            x = false;
            y = false;
            a = false;
            b = false;
            start = false;
            leftTrigger = false;
            rightTrigger = false;
            leftStick = Vector2.Zero;
            rightStick = Vector2.Zero;
            
        }
    }
    
    class GamePadController: MouseTrailController
    {
        GamePadInfo info;
        bool triggerButtonPushed = false;
        public GamePadController(ICamera camera, GameWindow window)
            : base(camera, window)
        {
            info = new GamePadInfo();
        }
        
        public override void act(GameTime time)
        {
            GamePadState state = GamePad.GetState(PlayerIndex.One);
            info.LeftStick = state.ThumbSticks.Left;

            Vector2 vel = state.ThumbSticks.Right*Const.MouseSpeed;
            vel *=  Camera.ViewWidth/Camera.ScreenSize;

            //System.Console.Write(Mouse.GetState().X + " ");
            Mouse.SetPosition(Mouse.GetState().X + (int)vel.X, Mouse.GetState().Y - (int)vel.Y);
            //System.Console.WriteLine(Mouse.GetState().X + " ");

            info.A = (state.Buttons.A == ButtonState.Pressed);
            info.B = (state.Buttons.B == ButtonState.Pressed);
            info.Y = (state.Buttons.Y == ButtonState.Pressed);
            info.X = (state.Buttons.X == ButtonState.Pressed);

            base.act(time); 
            
            if (Target != null)
                Target.control(info);
        }
        protected override void updateTrail()
        {
            base.updateTrail();
            GamePadState state = GamePad.GetState(PlayerIndex.One);
            if (trailInfo.Type == MouseType.None)
            {
                trailInfo.Trail.Clear();
                if (state.Triggers.Right >= Const.TriggerThreshold)
                {
                    trailInfo.Type = MouseType.Offensive;
                    triggerButtonPushed = true;
                }
                else if (state.Triggers.Left >= Const.TriggerThreshold)
                {
                    trailInfo.Type = MouseType.Defensive;
                    triggerButtonPushed = true;
                }
            }
            if (trailInfo.Type == MouseType.Offensive && triggerButtonPushed)
            {
                if (state.Triggers.Right < Const.TriggerThreshold)
                {
                    triggerButtonPushed = false;
                    trailInfo.Finished = true;
                }
                else
                {
                    trailInfo.Trail.Add(CurrentMousePosition);
                }
            }

            if (trailInfo.Type == MouseType.Defensive && triggerButtonPushed)
            {
                if (state.Triggers.Left <= Const.TriggerThreshold)
                {
                    triggerButtonPushed = false;
                    trailInfo.Finished = true;
                }
                else
                {
                    trailInfo.Trail.Add(CurrentMousePosition);
                }
            }
        }
        public override void cleanup()
        {
            
        }
    }
}
