﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Cursed.gob.mob.kob;
using Cursed.gob.mob;

namespace Cursed.input.ai
{
    class EnemySpiritController : Controller
    {
        private Mob goal;
        private RangeDetector range;

        public EnemySpiritController(CursedGame game, Spirit target, int radius)
            :base()
        {
            this.Push(target);
            MobInfo info = new MobInfo();
            info.Loc = Spirit.Loc;
            this.range = new RangeDetector(game, info, radius, target.SpiritInfo.Loc);
            this.range.clearRenders();
            game.AddGob(this.range);

        }
        public override void act(Microsoft.Xna.Framework.GameTime time)
        {
            range.MobInfo.Loc = Spirit.SpiritInfo.Loc;
            foreach(Gob gob in range.TouchedGobs)
            {
                if (gob is Druid)
                {
                    goal = gob;
                }
            }
            
        }
        public Spirit Spirit
        {
            get { return (Spirit)Target; }
        }
    }
}
