﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Cursed.gob.mob.kob;
using Cursed.gob.mob;
using Microsoft.Xna.Framework;

namespace Cursed.input.ai
{
    public class EvilDruidControl : Controller
    {
        Druid druid;
        MouseCursorInfo mci;
        bool resting;

        public EvilDruidControl(Druid druid)
        {
            this.druid = druid;
            mci = new MouseCursorInfo();
            Push(druid);
            resting = false;
        }

        public override void act(Microsoft.Xna.Framework.GameTime time)
        {
            Druid enemy = null;
            Familiar enemyFamiliar = null;


            if (druid.DruidInfo.CurrentMana <= 0)
                resting = true;
            if (druid.DruidInfo.CurrentMana >= druid.DruidInfo.MaxMana * .5f)
                resting = false;

            foreach (Mob mob in druid.SeenMobs)
            {
                if (mob is Druid)
                {
                    Druid d = (Druid)mob;
                    if (d.DruidInfo.IsPlayer)
                        enemy = d;
                }
                if (mob is Familiar)
                {
                    Familiar f = (Familiar)mob;
                    if (f.Master.DruidInfo.IsPlayer)
                        enemyFamiliar = f;
                }
            }

            if (enemy == null)
                return;

            mci.Type = MouseType.None;

            if (enemy.KobInfo.Energy < 1 && !resting)
            {
                mci.Clicked = true;
                mci.Mouse = .1f * enemy.GobInfo.Loc + .9f * mci.Mouse;
                mci.Type = MouseType.Offensive;
                druid.control(mci);
            }
            else if (enemyFamiliar != null && !resting)
            {

                mci.Clicked = true;

                Vector2 d = enemyFamiliar.GobInfo.Loc * .5f + druid.GobInfo.Loc * .5f;
                mci.Mouse = .1f * d + .9f * mci.Mouse;
                mci.Type = MouseType.Defensive;
                druid.control(mci);
            }
            else
            {
                MouseTrailInfo mti = new MouseTrailInfo();
                mti.Finished = true;
                druid.control(mti);
            }

            if (enemyFamiliar != null)
            {

            }

        }

        public override void cleanup()
        {

        }
    }
}
