﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;

namespace Cursed.input.ai.rl
{
    public class QTable
    {
        Hashtable qvalues;
        Hashtable values;

        public QTable()
        {
            qvalues = new Hashtable();
            values = new Hashtable();
        }

        public Action GetAction(State state)
        {
            Action best = (Action)CursedGame.Random.Next((int)Action._MAX_);
            float bestQ = this[state, best];
            for (int i = 1; i < (int)Action._MAX_; i++)
            {
                Action a = (Action)(((int)best + i) % (int)Action._MAX_);
                float q = this[state, a];
                if (q > bestQ)
                {
                    bestQ = q;
                    best = a;
                }
            }
            return best;
        }

        public float this[State state]
        {
            get
            {
                int si = state.Index;
                if (values.ContainsKey(si))
                {
                    return (float)values[si];
                }
                else
                {
                    return (float)(values[si] = state.H());
                }
            }
        }

        public float this[State state, Action action]
        {
            get
            {
                int si = state.Index;
                int i = si*(int)Action._MAX_+(int)action;
                if (qvalues.ContainsKey(i))
                {
                    return (float)qvalues[i];
                }
                else
                {
                    return (float)(qvalues[i] = state.H());
                }
            }
            set
            {
                lock (this)
                {
                    int si = state.Index;
                    int i = si * (int)Action._MAX_ + (int)action;
                    float q;
                    if (qvalues.ContainsKey(i))
                    {
                        q = (float)qvalues[i];
                    }
                    else
                    {
                        q = state.H();
                    }
                    float v;
                    if (values.ContainsKey(si))
                    {
                        v = (float)values[si];
                    }
                    else
                    {
                        values[si] = v = state.H();
                    }

                    qvalues[i] = value;
                    if (value > v)
                        values[si] = value;
                    else
                    {
                        if (q >= v)
                        {
                            for (int ni = si; ni < si + (int)Action._MAX_; ni++)
                            {
                                float nqi;
                                if (qvalues.ContainsKey(ni))
                                    nqi = (float)values[si];
                                else
                                    values[si] = nqi = state.H();
                                v = Math.Max(v, nqi);
                            }
                            values[si] = v;
                        }
                    }
                }
            }
        }
    }
}
