﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Cursed.sound
{
    class SimpleSound : Sound
    {
        SoundManager mngr = null;
        public SimpleSound(SoundBank bank,SoundManager mngr, String filename)
        {
            current = bank.getInstance(filename);
            current.Volume = .5f;
            current.IsLooped = false;
            this.mngr = mngr;

        }
        public SimpleSound(SoundBank bank,SoundManager mngr, String filename, float volume)
        {
            current = bank.getInstance(filename);
            current.Volume = volume;
            current.IsLooped = false;
            this.mngr = mngr;
        }
        public SimpleSound(SoundBank bank, SoundManager mngr, String filename, float volume, bool loop)
        {
            current = bank.getInstance(filename);
            current.Volume = volume;
            current.IsLooped = loop;
            this.mngr = mngr;
        }
        public override void play()
        {
            mngr.addSound(this);
        }
        public override void stop()
        {
            mngr.removeSound(this);
        }
        public override float Volume
        {
            get
            {
                return current.Volume;
            }
            set
            {
                current.Volume = value;
            }
        }
    }
}
