﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Cursed.gob.tile;
using Cursed.gob;
using Cursed.gob.mob.kob;
using Microsoft.Xna.Framework;
using Cursed.gob.mob.effects;
using Cursed.gob.mob;
using Microsoft.Xna.Framework.Graphics;

namespace Cursed.ui
{


    public class Levels
    {

        public static List<GobInfo> InfoTest0()
        {
            List<GobInfo> infos = new List<GobInfo>();

            DruidInfo druidInfo = new DruidInfo();
            druidInfo.Loc = new Vector2(3, 3);
            druidInfo.IsPlayer = false;
            infos.Add(druidInfo);

            for (int x = 0; x < 9; x++)
            {
                for (int y = 0; y < 9; y++)
                {
                    infos.Add(new GroundInfo(x - 4, y - 4));
                }
                infos.Add(new WallInfo(x - 4, -5));
                infos.Add(new WallInfo(x - 4, 5));
            }
            for (int y = -1; y < 10; y++)
            {
                infos.Add(new WallInfo(-5, y - 4));
                infos.Add(new WallInfo(5, y - 4));
            }

            infos.Add(new DoorInfo(-3, -3));
            infos.Add(new FootSwitchInfo(-3, -2));

            UINewGameTileInfo newGameTile = new UINewGameTileInfo(-4, -4);
            newGameTile.Level = "StartScreen";
            infos.Add(newGameTile);

            return infos;
        }
        public static List<GobInfo> InfoTest1()
        {
            List<GobInfo> infos = new List<GobInfo>();

            EntranceInfo ei = new EntranceInfo(0, -2);
            ei.Label = "start";
            infos.Add(ei);

            //first room
            for (int x = -3; x <= 3; x++)
                for (int y = -3; y <= 3; y++)
                {
                    infos.Add(new GroundInfo(x, y));
                }
            for (int y = -3; y <= 3; y++)
            {
                infos.Add(new WallInfo(-4, y));
                infos.Add(new WallInfo(4, y));
            }
            for (int x = -4; x <= 4; x++)
            {
                infos.Add(new WallInfo(x, -4));
                if (x < -2 || x > 2)
                    infos.Add(new WallInfo(x, 4));
            }

            //second room
            for (int y = 4; y < 10; y++)
            {
                infos.Add(new WallInfo(-2, y));
                infos.Add(new WallInfo(2, y));
                for (int x = -1; x <= 1; x++)
                {
                    infos.Add(new GroundInfo(x, y));
                }
            }
            for (int y = 10; y < 13; y++)
            {
                infos.Add(new WallInfo(-2, y));
                for (int x = -1; x <= 2; x++)
                {
                    infos.Add(new GroundInfo(x, y));
                }
            }
            for (int x = -2; x <= 2; x++)
            {
                if (x == 0)
                {
                    infos.Add(new GroundInfo(x, 13));
                }
                else
                {
                    infos.Add(new WallInfo(x, 13));
                }
            }
            for (int y = 9; y <= 13; y++)
            {
                for (int x = 2; x < 4; x++)
                {
                    if (y == 11 || x == 2)
                    {
                        infos.Add(new GroundInfo(x, y));
                    }
                    else
                    {
                        infos.Add(new WallInfo(x, y));
                    }
                }
            }

            //room 3
            infos.Add(new WallInfo(4, 13));
            for (int y = 14; y <= 16; y++)
                for (int x = -1; x <= 1; x++)
                    infos.Add(new GroundInfo(x, y));
            for (int y = 14; y <= 17; y++)
            {
                infos.Add(new WallInfo(-2, y));
                infos.Add(new WallInfo(2, y));
            }
            for (int x = -2; x <= 2; x++)
                infos.Add(new WallInfo(x, 17));

            //room 4
            for (int x = 3; x <= 12; x++)
                for (int y = 10; y <= 12; y++)
                    infos.Add(new GroundInfo(x, y));
            for (int x = 6; x <= 12; x++)
                for (int y = 13; y <= 18; y++)
                    infos.Add(new GroundInfo(x, y));
            for (int x = 3; x <= 13; x++)
                infos.Add(new WallInfo(x, 9));
            for (int y = 10; y <= 19; y++)
            {
                if (y == 13)
                {
                    continue;
                }
                infos.Add(new WallInfo(13, y));
            }
            for (int x = 6; x <= 12; x++)
            {
                infos.Add(new WallInfo(x, 19));
            }
            for (int y = 13; y <= 19; y++)
            {
                infos.Add(new WallInfo(5, y));
            }
            WallInfo wi2 = new WallInfo(4, 13);

            //room 5
            for (int x = 14; x <= 24; x++)
            {
                for (int y = 7; y < 22; y++)
                {
                    infos.Add(new GroundInfo(x, y));
                }
                infos.Add(new WallInfo(x, 6));
                infos.Add(new WallInfo(x, 22));
            }
            for (int y = 6; y <= 22; y++)
            {
                if (y < 12 || y > 14)
                {
                    infos.Add(new WallInfo(25, y));
                    infos.Add(new WallInfo(13, y));
                }
            }
            for (int x = 25; x < 35; x++)
            {
                infos.Add(new WallInfo(x, 11));
                infos.Add(new WallInfo(x, 15));
                for (int y = 12; y <= 14; y++)
                {
                    infos.Add(new GroundInfo(x, y));
                }
            }
            for (int y = 11; y <= 15; y++)
            {
                infos.Add(new WallInfo(35, y));
            }
            for (int x = 18; x <= 20; x++)
            {
                for (int y = 15; y < 17; y++)
                {
                    infos.Add(new WallInfo(x, y));
                }
                for (int y = 10; y < 12; y++)
                {
                    infos.Add(new WallInfo(x, y));
                }
            }

            FootSwitchInfo switchI = new FootSwitchInfo(0, 14);
            switchI.Label = "door1";
            infos.Add(switchI);

            DoorInfo doorI = new DoorInfo(0, 13);
            doorI.Label = "door1";
            infos.Add(doorI);

            doorI = new DoorInfo(3, 11);
            doorI.Label = "door2";
            infos.Add(doorI);

            switchI = new FootSwitchInfo(-1, 11);
            switchI.Label = "door2";
            infos.Add(switchI);

            switchI = new FootSwitchInfo(4, 11);
            switchI.Label = "door2";
            infos.Add(switchI);

            doorI = new DoorInfo(13, 13);
            doorI.Label = "door3";
            infos.Add(doorI);
            infos.Add(new GroundInfo(13, 13));

            switchI = new FootSwitchInfo(12, 13);
            switchI.Label = "door3";
            infos.Add(switchI);


            DemonInfo dmi = new DemonInfo();
            dmi.Loc = new Vector2(0, 8);
            infos.Add(dmi);

            dmi = new DemonInfo();
            dmi.Transparency = .2f;
            dmi.Scale = .5f;
            dmi.Loc = new Vector2(-1, 16);
            infos.Add(dmi);

            dmi = new DemonInfo();
            dmi.Transparency = .1f;
            dmi.Scale = .5f;
            dmi.Loc = new Vector2(1, 16);
            infos.Add(dmi);

            dmi = new DemonInfo();
            dmi.Transparency = .1f;
            dmi.Scale = .5f;
            dmi.Loc = new Vector2(0, 16);
            infos.Add(dmi);

            for (int x = 6; x <= 12; x++)
                for (int y = 15; y <= 17; y++)
                {
                    dmi = new CraniumRatInfo();
                    dmi.Loc = new Vector2(x, y);
                    infos.Add(dmi);
                }

            dmi = new DemonInfo();
            dmi.MaxHealth = 5;
            dmi.CurrentHealth = 5;
            dmi.Scale = 2;
            dmi.Thrust = 8;
            dmi.StrengthFactor = 2;
            dmi.ViewRange = 12;
            dmi.LungeDuration = 1;
            dmi.LungeFactor = 4;
            dmi.Loc = new Vector2(33, 13);
            infos.Add(dmi);

            UINewGameTileInfo newGameTile = new UINewGameTileInfo(33, 13);
            newGameTile.Level = "StartScreen";
            infos.Add(newGameTile);

            return infos;
        }
        public static List<GobInfo> StartScreen()
        {
            List<GobInfo> infos = new List<GobInfo>();
            UIFamiliarInfo uiFamInfo = new UIFamiliarInfo();
            uiFamInfo.Loc = new Vector2(0, 0);
            infos.Add(uiFamInfo);
            return infos;
        }
        /*
        public static List<GobInfo> StartScreen()
        {
            List<GobInfo> infos = new List<GobInfo>();

            infos.Add(new EntranceInfo(0, 0));

            UIFamiliarInfo uiFamInfo = new UIFamiliarInfo();
            uiFamInfo.Loc = new Vector2(0, 0);
            infos.Add(uiFamInfo);

            for (int x = -10; x <= 10; x++)
            {
                for (int y = -10; y <= 10; y++)
                {
                    GroundInfo groundInfo = new GroundInfo(x, y);
                    infos.Add(groundInfo);
                }
            }

            UINewGameTileInfo newGameTile = new UINewGameTileInfo(0, 4);
            newGameTile.Level = "tutorial";
            newGameTile.Label = "start";
            infos.Add(newGameTile);
            newGameTile = new UINewGameTileInfo(3, 3);
            newGameTile.Level = "timlevel";
            newGameTile.Label = "start";
            infos.Add(newGameTile);
            newGameTile = new UINewGameTileInfo(-3, 3);
<<<<<<< HEAD
            newGameTile.Level = "finallevel1";
=======
            newGameTile.Level = "finallevel2";
>>>>>>> c8bc2d77c5c1105a2ca451261fee285eb8b15b5c
            newGameTile.Label = "start";
            infos.Add(newGameTile);
            newGameTile = new UINewGameTileInfo(0, -4);
            newGameTile.Level = "techdemo";
            newGameTile.Label = "start";
            newGameTile.Mask = Color.Green;
            infos.Add(newGameTile);

            StickerInfo stickerInfo = new StickerInfo();
            stickerInfo.Preset = "ExperimentalLevels";
            stickerInfo.Depth = Const.ExitDepth;
            stickerInfo.Loc = new Vector2(0, 5);
            infos.Add(stickerInfo);
            stickerInfo = new StickerInfo();
            stickerInfo.Preset = "TechDemo";
            stickerInfo.Depth = Const.ExitDepth;
            stickerInfo.Loc = new Vector2(0, -5);
            infos.Add(stickerInfo);

            return infos;
        }*/
    }
}
