﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Cursed.input;
using Cursed.gob.mob.kob;
using Cursed.gob;
using Cursed.gob.mob;
using Microsoft.Xna.Framework;
using Cursed.input.ai;

namespace Cursed.ui
{
    public class UIFamiliarInfo : MobInfo
    {
        public UIFamiliarInfo()
            : base()
        {

        }

        public override Gob Create(CursedGame game)
        {
            return new UIFamiliar(game, this);
        }
    }

    public class UIFamiliar : Mob
    {
        GamePadController gamePadController;
        Wand wand;

        public UIFamiliar(CursedGame game, UIFamiliarInfo info)
            : base(game, info)
        {
            
        }

        public override void Load()
        {
            HasHands = false;
            base.Load();
            WandInfo wandInfo = new WandInfo();
            wand = (Wand)wandInfo.Create(CursedGame);
            CursedGame.AddGob(wand);
            gamePadController = new GamePadController(CursedGame.Camera, CursedGame.Window);
            gamePadController.Push(this);
            CursedGame.AddController(gamePadController);
        }

        public override void Unload()
        {
            CursedGame.RemoveController(gamePadController);
           
            base.Unload();
        }

       

        #region IControllable Members

        public override void control(ControlInfo info)
        {
            if (info is MouseCursorInfo)
            {
                MouseCursorInfo mouseCursorInfo = (MouseCursorInfo)info;
                wand.GobInfo.Loc = mouseCursorInfo.Mouse;
            }
            /*if (info is MouseTrailInfo)
            {
                MouseTrailInfo mouseTrailInfo = (MouseTrailInfo)info;
                Vector2 loc = mouseTrailInfo.Trail[mouseTrailInfo.Trail.Count - 1];
                if (Ready)
                {
                    LifeBlobInfo lifeInfo = new LifeBlobInfo();
                    lifeInfo.Loc = loc;
                    lifeInfo.Amount = Const.LifeSpellAmount;
                    LifeBlob blob = (LifeBlob)lifeInfo.Create(CursedGame);
                    CursedGame.AddGob(blob);
                    CoolDown += Const.LifeSpellCoolDown;
                }
            }*/
            base.control(info);
        }
        #endregion
    }
}
