﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;
using Cursed.input;

namespace Cursed.view
{
    class Console : IControllable
    {
        private List<String> lines;
        private string currentLine;
        private bool enabled;
        private SpriteFont font;
        private Texture2D background;
        private Color backColor;
        private int lineLimit;
        CursedGame game;

        public Console(CursedGame game)
        {
            font = game.Content.Load<SpriteFont>("fonts\\console");
            background = game.Content.Load<Texture2D>("Images\\square");
            enabled = false;
            this.game = game;
            backColor = new Color(.7f,1f,.7f,.1f);

        }
        public void Draw(SpriteBatch spriteBatch)
        {
            if (!enabled) return;
            
            int width = game.Window.ClientBounds.Width;
            int height = font.LineSpacing * lineLimit;
            //spriteBatch.Begin(SpriteBlendMode.AlphaBlend, SpriteSortMode.Immediate, SaveStateMode.SaveState);
            game.SpriteBatch.Draw(background, new Rectangle(0, 0, width, height), backColor);
            int pos = 0;
            for (int i = 0; i < lines.Count; i++)
            {
                
                spriteBatch.DrawString(font, lines[i], new Vector2(0, pos), Color.White);
                pos += font.LineSpacing;
            }
            if(currentLine != null)
                spriteBatch.DrawString(font, currentLine, new Vector2(0, pos), Color.White);

            //spriteBatch.End();
            enabled = false;
        }
        public void control(ControlInfo info)
        {
            TextInputInfo tInfo = (TextInputInfo)info;
            if (tInfo.Active) currentLine = ">";
            else currentLine = "";
            this.currentLine += tInfo.InProgress;
            this.lines = tInfo.Lines;
            this.lineLimit = tInfo.LineLimit;
            enabled =true;
        }
    }
}
