﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework;
using System.Windows;
using Cursed.geom;

namespace Cursed.view.renders
{
    public class LifebarRenderInfo : SpriteRenderInfo
    {
        public LifebarRenderInfo(Bounds bounds)
            :base(bounds)
        {
            frontColor = Color.Red;
            backColor = Color.Black;
            visibility = 1;
            percent = 1;
        }
        float visibility;

        public float Visibility
        {
            get { return visibility; }
            set { visibility = value; }
        }
        float percent;

        public float Percent
        {
            get { return percent; }
            set { percent = value; }
        }
        Color frontColor;
        public Color FrontColor
        {
            get { return frontColor; }
            set { backColor = value; }
        }
        Color backColor;

        public Color BackColor
        {
            get { return backColor; }
            set { backColor = value; }
        }
        public void SetDrawnFrame(float percentx, float percenty)
        {
            drawnFrame = new Bounds((1 - percentx) / 2, 0, percentx + (1 - percentx) / 2, 1);
        }
    }
    class LifebarRender : SpriteRender
    {
        public LifebarRender(GraphicsDevice gd, Effect effect)
            : base(gd, effect)
        {

        }
        public override void Draw(GameTime time, RenderInfo info)
        {
            effect.Parameters["BasicTexture"].SetValue(info.Texture);
            if (info.Transform != null)
            {
                effect.Parameters["World"].SetValue(info.Transform);
            }
            LifebarRenderInfo ri = (LifebarRenderInfo)info;
            Color temp = ri.BackColor;
            temp.A = (byte)(ri.Visibility*255);
            ri.Mask = temp;
            ri.SetDrawnFrame(1f,1f);
            ri.scaleX = 1;
            base.Draw(time, info);

            temp = ri.FrontColor;
            temp.A = (byte)(ri.Visibility * 255);
            ri.Mask = temp;
            ri.scaleX = ri.Percent;
            ri.SetDrawnFrame(ri.Percent, ri.Percent);
            base.Draw(time, info);
        }
        
    }
}
